﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Lab5
{
    public class Parser
    {
        private Scanner scanner;
        private Token token;

        public bool Error { get; private set; }
        public List<int> Rules { get; } = new List<int>();
        public Parser(Scanner scanner)
        {
            this.scanner = scanner;
            this.token = scanner.NextToken();
        }
        private void expect(TokenType expected)
        {
            if (token.Type == expected)
            {
                token = scanner.NextToken();
            }else
            {
                Error = true;
            }
        }
        public void E()
        {
            Rules.Add(1);
            T();
            E1();
        }
        void E1()
        {
            if (token.Type == TokenType.PLUS)
            {
                Rules.Add(2);
                expect(TokenType.PLUS);
                T();
                E1();
            } else if (token.Type == TokenType.MINUS)
            {
                Rules.Add(3);
                expect(TokenType.MINUS);
                T();
                E1();
            }
            else if (token.Type == TokenType.RightPAR || token.Type == TokenType.EOL)
            {
                Rules.Add(4);
            }
            else
            {
                Error = true;
            }
        }
        void T()
        {
            Rules.Add(5);
            F();
            T1();
        }
        void T1()
        {
            if (token.Type == TokenType.MUL)
            {
                Rules.Add(6);
                expect(TokenType.MUL);
                F();
                T1();
            }
            else if (token.Type == TokenType.DIV)
            {
                Rules.Add(7);
                expect(TokenType.DIV);
                F();
                T1();
            }
            else if (token.Type == TokenType.RightPAR || token.Type == TokenType.EOL
                || token.Type == TokenType.MINUS || token.Type == TokenType.PLUS)
            {
                Rules.Add(8);
            }
            else
            {
                Error = true;
            }
        }
        void F()
        {
            if (token.Type == TokenType.LeftPAR)
            {
                Rules.Add(9);
                expect(TokenType.LeftPAR);
                E();
                expect(TokenType.RightPAR);
            }
            else if (token.Type == TokenType.NUMBER)
            {
                Rules.Add(10);
                expect(TokenType.NUMBER);
            }
            else
            {
                Error = true;
            }
        }
    }
}
